#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "Image.h"

struct image
{
  unsigned short **data;
  int largeur;
  int hauteur;
};

static void initImage(Image this,int largeur, int hauteur)
{
  this->data =  malloc(sizeof(short *)*hauteur);
  for(int i = 0; i < hauteur; i++)
    {
      this->data[i] = malloc(sizeof(short)*largeur);
      assert(this->data[i]!=NULL);
      for(int j = 0; j < largeur; j++)
	this->data[i][j] = 0;
    }
  this->largeur = largeur;
  this->hauteur = hauteur;
}

Image   creerImage(int largeur, int hauteur)
{
  Image this = malloc(sizeof(struct image));
  assert(this!=NULL);
  initImage(this,largeur, hauteur);
  return this;
}

void  libererImage(Image this)
{
  for(int i=0; i < lireHauteurImage(this); i++)
    free(this->data[i]);
  free(this->data);
  free(this);
}


Image   copieImage(Image this)
{
  return extractSubImage(this,0,0,this->largeur, this->hauteur);
}


unsigned short   lirePixelImage(Image this, int coordX, int coordY)
{
  assert(coordX >= 0 && coordX < lireLargeurImage(this));
  assert(coordY >= 0 && coordY < lireHauteurImage(this));
  
  return this->data[coordY][coordX];
}


void  ecrirePixelImage(Image this, int coordX, int coordY, unsigned short c)
{
  assert(coordX >= 0 && coordX < lireLargeurImage(this));
  assert(coordY >= 0 && coordY < lireHauteurImage(this));
  
  this->data[coordY][coordX] = c;
}

int lireLargeurImage(Image this)
{
  return this->largeur;
}

int lireHauteurImage(Image this)
{
  return this->hauteur;
}

Image  extractSubImage(Image this, int x, int y, int largeur, int hauteur)
{
  assert(x+largeur >= 0 && x+largeur <= lireLargeurImage(this));
  assert(y+hauteur >= 0 && x+hauteur <= lireHauteurImage(this));

  Image subImage = creerImage(largeur,hauteur);
  
  for(int i = 0; i < largeur; i++)
    for(int j = 0; j < hauteur; j++)
      ecrirePixelImage(subImage,i,j,lirePixelImage(this,i+x,j+y));

  return subImage;
}

void afficheImage(Image this)
{
  for(int j = 0; j < lireHauteurImage(this); j++)
    {
      for(int i = 0; i < lireLargeurImage(this); i++)
	printf(" %d " , lirePixelImage(this,i,j));
      printf(" \n");
    }
}


